// HashContainer.cpp: implementation of the CHashContainer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HashContainer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////

CHashContainer::CHashContainer()
{
}

CHashContainer::~CHashContainer()
{
}

void CHashContainer::AddHash(CString sHash)
{
	if (sHash == "aad3b435b51404ee")
		return;

	CString sPlain;
	if (m_mapHashPlain.Lookup(sHash, sPlain) == 0)
		m_mapHashPlain[sHash] = PLAIN_NOT_FOUNT;
}

void CHashContainer::GetAllLeftHash(CStringArray& arrLeftHash)
{
	arrLeftHash.RemoveAll();

	POSITION pos;
	for (pos = m_mapHashPlain.GetStartPosition(); pos != NULL;)
	{
		CString sKey, sValue;
		m_mapHashPlain.GetNextAssoc(pos, sKey, sValue);
		if (sValue == PLAIN_NOT_FOUNT)
			arrLeftHash.Add(sKey);
	}
}

void CHashContainer::SetPlainOfHash(CString sHash, CString sPlain)
{
	m_mapHashPlain[sHash] = sPlain;
}

CString CHashContainer::GetPlainOfHash(CString sHash)
{
	if (sHash == "aad3b435b51404ee")
		return "       ";

	POSITION pos;
	for (pos = m_mapHashPlain.GetStartPosition(); pos != NULL;)
	{
		CString sKey, sValue;
		m_mapHashPlain.GetNextAssoc(pos, sKey, sValue);
		if (sKey == sHash)
			return sValue;
	}
	return PLAIN_NOT_FOUNT;
}

BOOL CHashContainer::AnyHashLeft()
{
	POSITION pos;
	for (pos = m_mapHashPlain.GetStartPosition(); pos != NULL;)
	{
		CString sKey, sValue;
		m_mapHashPlain.GetNextAssoc(pos, sKey, sValue);
		if (sValue == PLAIN_NOT_FOUNT)
			return TRUE;
	}
	return FALSE;
}

void CHashContainer::GetStatistics(int& nPlainTextFound, int& nHashTotal)
{
	nPlainTextFound = 0;
	nHashTotal = 0;
	POSITION pos;
	for (pos = m_mapHashPlain.GetStartPosition(); pos != NULL;)
	{
		CString sKey, sValue;
		m_mapHashPlain.GetNextAssoc(pos, sKey, sValue);
		if (sValue != PLAIN_NOT_FOUNT)
			nPlainTextFound++;
		nHashTotal++;
	}
}
