// HashContainer.h: interface for the CHashContainer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HASHCONTAINER_H__F2E895F8_67F0_4455_8BCB_2A5F9C0087A7__INCLUDED_)
#define AFX_HASHCONTAINER_H__F2E895F8_67F0_4455_8BCB_2A5F9C0087A7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define PLAIN_NOT_FOUNT "<notfound>"

class CHashContainer
{
public:
	CHashContainer();
	virtual ~CHashContainer();

private:
	CMapStringToString m_mapHashPlain;

public:
	void AddHash(CString sHash);	// lowercase, length 16
	void GetAllLeftHash(CStringArray& arrLeftHash);
	void SetPlainOfHash(CString sHash, CString sPlain);
	CString GetPlainOfHash(CString sHash);
	BOOL AnyHashLeft();
	void GetStatistics(int& nPlainTextFound, int& nHashTotal);
};

#endif // !defined(AFX_HASHCONTAINER_H__F2E895F8_67F0_4455_8BCB_2A5F9C0087A7__INCLUDED_)
