// RainbowChainWalkContainer.h: interface for the CRainbowChainWalkContainer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RAINBOWCHAINWALKCONTAINER_H__8D1576EA_CD06_4990_99C3_3243E081D3D2__INCLUDED_)
#define AFX_RAINBOWCHAINWALKCONTAINER_H__8D1576EA_CD06_4990_99C3_3243E081D3D2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct RainbowChainWalk
{
	BYTE Hash[8];
	unsigned __int64* pIndexE;	// mapGuessedStartPositionIndexE, length = nRainbowChainLength - 1
};

class CRainbowChainWalkContainer
{
public:
	CRainbowChainWalkContainer();
	virtual ~CRainbowChainWalkContainer();

private:
	CString m_sPlainCharset;		// Discard all if this one not match
	int     m_nRainbowTableIndex;	// Discard all if this one not match
	int     m_nRainbowChainLength;	// Discard all if this one not match
	CArray<RainbowChainWalk,RainbowChainWalk> m_arrRainbowChainWalk;

private:
	void DiscardAll();

public:	
	BOOL RequestWalk(CString sPlainCharset, int nRainbowTableIndex,
					 int nRainbowChainLength, RainbowChainWalk& rcw);	// return whether newly generated
	void DiscardWalk(RainbowChainWalk rcw);
};

#endif // !defined(AFX_RAINBOWCHAINWALKCONTAINER_H__8D1576EA_CD06_4990_99C3_3243E081D3D2__INCLUDED_)
